"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PostgresEventStorageAdapter = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _postgres = _interopRequireDefault(require("postgres"));

var _core = require("@castore/core");

var _error = require("./error");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18, _templateObject19, _templateObject20, _templateObject21, _templateObject22, _templateObject23, _templateObject24, _templateObject25, _templateObject26, _templateObject27, _templateObject28, _templateObject29, _templateObject30, _templateObject31, _templateObject32, _templateObject33, _templateObject34, _templateObject35, _templateObject36, _templateObject37, _templateObject38, _templateObject39, _templateObject40, _templateObject41, _templateObject42, _templateObject43, _templateObject44, _templateObject45, _templateObject46, _templateObject47;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var assertIsSerializableParameter = function assertIsSerializableParameter(value) {
  if (!value) {
    throw new Error("Payload is required");
  }

  if ((0, _typeof2["default"])(value) !== 'object' || Array.isArray(value)) {
    throw new Error("Payload must be a plain object");
  }
};

var PostgresEventStorageAdapter = /*#__PURE__*/function () {
  function PostgresEventStorageAdapter() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$connectionString = _ref.connectionString,
        connectionString = _ref$connectionString === void 0 ? 'postgresql://postgres:postgres@localhost:5432/postgres' : _ref$connectionString,
        _ref$tableName = _ref.tableName,
        tableName = _ref$tableName === void 0 ? 'event' : _ref$tableName;

    (0, _classCallCheck2["default"])(this, PostgresEventStorageAdapter);
    (0, _defineProperty2["default"])(this, "_sql", void 0);
    (0, _defineProperty2["default"])(this, "_tableName", void 0);
    this._tableName = tableName;
    this._sql = PostgresEventStorageAdapter.createClient({
      connectionString: connectionString
    });
  }

  (0, _createClass2["default"])(PostgresEventStorageAdapter, [{
    key: "toEventDetail",
    value: function toEventDetail(event) {
      var eventDetail = {
        aggregateId: event.aggregate_id,
        version: Number(event.version),
        type: event.type,
        payload: event.data,
        metadata: event.metadata,
        timestamp: event.timestamp.toISOString()
      };
      if (!eventDetail.payload) delete eventDetail.payload;
      if (!eventDetail.metadata) delete eventDetail.metadata;
      return eventDetail;
    }
  }, {
    key: "pushEvent",
    value: function () {
      var _pushEvent = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(eventDetail, options) {
        var _this = this,
            _ref2,
            _ref3;

        var aggregateId, version, type, payload, metadata, timestamp, onForced, payloadValue, metadataValue, INSERT, VALUES, query, res, insertedEvent;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                aggregateId = eventDetail.aggregateId, version = eventDetail.version, type = eventDetail.type, payload = eventDetail.payload, metadata = eventDetail.metadata, timestamp = eventDetail.timestamp;
                if (payload) assertIsSerializableParameter(payload);
                if (metadata) assertIsSerializableParameter(metadata);

                onForced = function onForced() {
                  return _this._sql(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2["default"])(["\n    \tON CONFLICT (aggregate_name, aggregate_id, version)\n      DO UPDATE SET\n        type = EXCLUDED.type,\n        data = EXCLUDED.data,\n        metadata = EXCLUDED.metadata,\n        timestamp = ", "\n\t\t"])), timestamp ? _this._sql(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2["default"])(["EXCLUDED.timestamp"]))) : _this._sql(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2["default"])(["CURRENT_TIMESTAMP(3)"]))));
                };

                payloadValue = (_ref2 = payload) !== null && _ref2 !== void 0 ? _ref2 : null;
                metadataValue = (_ref3 = metadata) !== null && _ref3 !== void 0 ? _ref3 : null;
                INSERT = timestamp ? this._sql(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2["default"])(["\n          INSERT INTO ", " (aggregate_name, aggregate_id, version, type, data, metadata, timestamp)\n        "])), this._sql.unsafe(this._tableName)) : this._sql(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2["default"])(["\n          INSERT INTO ", " (aggregate_name, aggregate_id, version, type, data, metadata)\n        "])), this._sql.unsafe(this._tableName));
                VALUES = timestamp ? this._sql(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2["default"])(["\n          VALUES (", ", ", ", ", ", ", ", ", ", ", ", ", ")\n        "])), options.eventStoreId, aggregateId, version, type, payloadValue, metadataValue, timestamp) : this._sql(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2["default"])(["\n          VALUES (", ", ", ", ", ", ", ", ", ", ", ")\n        "])), options.eventStoreId, aggregateId, version, type, payloadValue, metadataValue);
                query = this._sql(_templateObject8 || (_templateObject8 = (0, _taggedTemplateLiteral2["default"])(["\n      ", "\n      ", "\n      ", "\n      RETURNING *\n    "])), INSERT, VALUES, options.force ? onForced() : this._sql(_templateObject9 || (_templateObject9 = (0, _taggedTemplateLiteral2["default"])([""]))));
                _context.next = 11;
                return query["catch"](function (err) {
                  if (err.code === '23505' && err.message.includes("".concat(_this._tableName, "_aggregate_name_aggregate_id_version_key"))) {
                    throw new _error.PostgresEventAlreadyExistsError({
                      eventStoreId: options.eventStoreId,
                      aggregateId: aggregateId,
                      version: version
                    });
                  }

                  throw err;
                });

              case 11:
                res = _context.sent;
                insertedEvent = res[0];

                if (insertedEvent) {
                  _context.next = 15;
                  break;
                }

                throw new Error('Failed to insert event');

              case 15:
                return _context.abrupt("return", {
                  event: this.toEventDetail(insertedEvent)
                });

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function pushEvent(_x, _x2) {
        return _pushEvent.apply(this, arguments);
      }

      return pushEvent;
    }()
  }, {
    key: "getEvents",
    value: function () {
      var _getEvents = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(aggregateId, context, options) {
        var _this2 = this;

        var order, limit, minVersion, maxVersion, query, events;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                order = options !== null && options !== void 0 && options.reverse ? this._sql(_templateObject10 || (_templateObject10 = (0, _taggedTemplateLiteral2["default"])(["ORDER BY version DESC"]))) : this._sql(_templateObject11 || (_templateObject11 = (0, _taggedTemplateLiteral2["default"])(["ORDER BY version ASC"])));
                limit = options !== null && options !== void 0 && options.limit ? this._sql(_templateObject12 || (_templateObject12 = (0, _taggedTemplateLiteral2["default"])(["LIMIT ", ""])), options.limit) : this._sql(_templateObject13 || (_templateObject13 = (0, _taggedTemplateLiteral2["default"])([""])));
                minVersion = options !== null && options !== void 0 && options.minVersion ? this._sql(_templateObject14 || (_templateObject14 = (0, _taggedTemplateLiteral2["default"])(["AND version >= ", ""])), options.minVersion) : this._sql(_templateObject15 || (_templateObject15 = (0, _taggedTemplateLiteral2["default"])([""])));
                maxVersion = options !== null && options !== void 0 && options.maxVersion ? this._sql(_templateObject16 || (_templateObject16 = (0, _taggedTemplateLiteral2["default"])(["AND version <= ", ""])), options.maxVersion) : this._sql(_templateObject17 || (_templateObject17 = (0, _taggedTemplateLiteral2["default"])([""])));
                query = this._sql(_templateObject18 || (_templateObject18 = (0, _taggedTemplateLiteral2["default"])(["\n      SELECT aggregate_id, version, type, data, metadata, timestamp \n      FROM ", "\n      WHERE aggregate_id = ", "\n      AND aggregate_name = ", "\n      ", "\n      ", "\n      ", "\n      ", "\n    "])), this._sql.unsafe(this._tableName), aggregateId, context.eventStoreId, minVersion, maxVersion, order, limit);
                _context2.next = 7;
                return query;

              case 7:
                events = _context2.sent;
                return _context2.abrupt("return", {
                  events: events.map(function (event) {
                    return _this2.toEventDetail(event);
                  })
                });

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getEvents(_x3, _x4, _x5) {
        return _getEvents.apply(this, arguments);
      }

      return getEvents;
    }()
  }, {
    key: "pushEventGroup",
    value: function () {
      var _pushEventGroup = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(options, groupedEvents_0) {
        var _this3 = this;

        var _len,
            groupedEvents,
            _key,
            allEvents,
            results,
            hasABadAdapter,
            _args5 = arguments;

        return _regenerator["default"].wrap(function _callee4$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                for (_len = _args5.length, groupedEvents = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
                  groupedEvents[_key - 2] = _args5[_key];
                }

                allEvents = [groupedEvents_0].concat(groupedEvents);
                results = [];
                hasABadAdapter = allEvents.some(function (groupedEvent) {
                  if (!(groupedEvent.eventStorageAdapter instanceof PostgresEventStorageAdapter)) return true;
                  return false;
                });

                if (!hasABadAdapter) {
                  _context5.next = 6;
                  break;
                }

                throw new Error('All events must be connected to a PostgresEventStorageAdapter');

              case 6:
                _context5.next = 8;
                return this._sql.begin( /*#__PURE__*/function () {
                  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(transaction) {
                    var _iterator, _step, _loop;

                    return _regenerator["default"].wrap(function _callee3$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            _iterator = _createForOfIteratorHelper(allEvents);
                            _context4.prev = 1;
                            _loop = /*#__PURE__*/_regenerator["default"].mark(function _loop() {
                              var _groupedEvent$eventSt, _groupedEvent$eventSt2, _groupedEvent$context, _ref5, _ref6;

                              var groupedEvent, eventDetail, aggregateId, version, type, payload, metadata, timestamp, aggregateName, payloadValue, metadataValue, onForced, INSERT, VALUES, query, res, insertedEvent;
                              return _regenerator["default"].wrap(function _loop$(_context3) {
                                while (1) {
                                  switch (_context3.prev = _context3.next) {
                                    case 0:
                                      groupedEvent = _step.value;
                                      eventDetail = groupedEvent.event;
                                      aggregateId = eventDetail.aggregateId, version = eventDetail.version, type = eventDetail.type, payload = eventDetail.payload, metadata = eventDetail.metadata, timestamp = eventDetail.timestamp;
                                      aggregateName = (_groupedEvent$eventSt = (_groupedEvent$eventSt2 = groupedEvent.eventStore) === null || _groupedEvent$eventSt2 === void 0 ? void 0 : _groupedEvent$eventSt2.eventStoreId) !== null && _groupedEvent$eventSt !== void 0 ? _groupedEvent$eventSt : (_groupedEvent$context = groupedEvent.context) === null || _groupedEvent$context === void 0 ? void 0 : _groupedEvent$context.eventStoreId;

                                      if (aggregateName) {
                                        _context3.next = 6;
                                        break;
                                      }

                                      throw new Error('Event store ID (Aggregate name) is required');

                                    case 6:
                                      if (payload) assertIsSerializableParameter(payload);
                                      if (metadata) assertIsSerializableParameter(metadata);
                                      payloadValue = (_ref5 = payload) !== null && _ref5 !== void 0 ? _ref5 : null;
                                      metadataValue = (_ref6 = metadata) !== null && _ref6 !== void 0 ? _ref6 : null;

                                      onForced = function onForced() {
                                        return transaction(_templateObject19 || (_templateObject19 = (0, _taggedTemplateLiteral2["default"])(["\n          ON CONFLICT (aggregate_name, aggregate_id, version)\n          DO UPDATE SET\n            type = EXCLUDED.type,\n            data = EXCLUDED.data,\n            metadata = EXCLUDED.metadata,\n            timestamp = ", "\n        "])), timestamp ? transaction(_templateObject20 || (_templateObject20 = (0, _taggedTemplateLiteral2["default"])(["EXCLUDED.timestamp"]))) : transaction(_templateObject21 || (_templateObject21 = (0, _taggedTemplateLiteral2["default"])(["CURRENT_TIMESTAMP(3)"]))));
                                      };

                                      INSERT = timestamp ? transaction(_templateObject22 || (_templateObject22 = (0, _taggedTemplateLiteral2["default"])(["\n          INSERT INTO ", " (aggregate_name, aggregate_id, version, type, data, metadata, timestamp)\n        "])), _this3._sql.unsafe(_this3._tableName)) : transaction(_templateObject23 || (_templateObject23 = (0, _taggedTemplateLiteral2["default"])(["\n          INSERT INTO ", " (aggregate_name, aggregate_id, version, type, data, metadata)\n        "])), _this3._sql.unsafe(_this3._tableName));
                                      VALUES = timestamp ? transaction(_templateObject24 || (_templateObject24 = (0, _taggedTemplateLiteral2["default"])(["\n          VALUES (", ", ", ", ", ", ", ", ", ", ", ", ", ")\n        "])), aggregateName, aggregateId, version, type, payloadValue, metadataValue, timestamp) : transaction(_templateObject25 || (_templateObject25 = (0, _taggedTemplateLiteral2["default"])(["\n          VALUES (", ", ", ", ", ", ", ", ", ", ", ")\n        "])), aggregateName, aggregateId, version, type, payloadValue, metadataValue);
                                      query = transaction(_templateObject26 || (_templateObject26 = (0, _taggedTemplateLiteral2["default"])(["\n          ", "\n          ", "\n          ", "\n          RETURNING *\n        "])), INSERT, VALUES, options.force ? onForced() : transaction(_templateObject27 || (_templateObject27 = (0, _taggedTemplateLiteral2["default"])([""]))));
                                      _context3.next = 16;
                                      return query["catch"](function (err) {
                                        if (err.code === '23505' && err.message.includes('event_aggregate_name_aggregate_id_version_key')) {
                                          throw new _error.PostgresEventAlreadyExistsError({
                                            eventStoreId: aggregateName,
                                            aggregateId: aggregateId,
                                            version: version
                                          });
                                        }

                                        throw err;
                                      });

                                    case 16:
                                      res = _context3.sent;
                                      insertedEvent = res[0];

                                      if (insertedEvent) {
                                        _context3.next = 20;
                                        break;
                                      }

                                      throw new Error('Failed to insert event');

                                    case 20:
                                      results.push({
                                        event: _this3.toEventDetail(insertedEvent)
                                      });

                                    case 21:
                                    case "end":
                                      return _context3.stop();
                                  }
                                }
                              }, _loop);
                            });

                            _iterator.s();

                          case 4:
                            if ((_step = _iterator.n()).done) {
                              _context4.next = 8;
                              break;
                            }

                            return _context4.delegateYield(_loop(), "t0", 6);

                          case 6:
                            _context4.next = 4;
                            break;

                          case 8:
                            _context4.next = 13;
                            break;

                          case 10:
                            _context4.prev = 10;
                            _context4.t1 = _context4["catch"](1);

                            _iterator.e(_context4.t1);

                          case 13:
                            _context4.prev = 13;

                            _iterator.f();

                            return _context4.finish(13);

                          case 16:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee3, null, [[1, 10, 13, 16]]);
                  }));

                  return function (_x8) {
                    return _ref4.apply(this, arguments);
                  };
                }());

              case 8:
                return _context5.abrupt("return", {
                  eventGroup: results
                });

              case 9:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee4, this);
      }));

      function pushEventGroup(_x6, _x7) {
        return _pushEventGroup.apply(this, arguments);
      }

      return pushEventGroup;
    }()
  }, {
    key: "groupEvent",
    value: function groupEvent(eventDetail) {
      return new _core.GroupedEvent({
        event: eventDetail,
        eventStorageAdapter: this
      });
    }
  }, {
    key: "parseInputs",
    value: function parseInputs(_ref7) {
      var _pageTokenParsed$limi, _pageTokenParsed$init, _pageTokenParsed$init2, _pageTokenParsed$reve;

      var inputOptions = _ref7.inputOptions;
      var pageTokenParsed = {};

      if (typeof (inputOptions === null || inputOptions === void 0 ? void 0 : inputOptions.pageToken) === 'string') {
        try {
          pageTokenParsed = JSON.parse(inputOptions.pageToken);
        } catch (error) {
          throw new Error('Invalid page token');
        }
      }

      return {
        limit: (_pageTokenParsed$limi = pageTokenParsed.limit) !== null && _pageTokenParsed$limi !== void 0 ? _pageTokenParsed$limi : inputOptions === null || inputOptions === void 0 ? void 0 : inputOptions.limit,
        initialEventAfter: (_pageTokenParsed$init = pageTokenParsed.initialEventAfter) !== null && _pageTokenParsed$init !== void 0 ? _pageTokenParsed$init : inputOptions === null || inputOptions === void 0 ? void 0 : inputOptions.initialEventAfter,
        initialEventBefore: (_pageTokenParsed$init2 = pageTokenParsed.initialEventBefore) !== null && _pageTokenParsed$init2 !== void 0 ? _pageTokenParsed$init2 : inputOptions === null || inputOptions === void 0 ? void 0 : inputOptions.initialEventBefore,
        reverse: (_pageTokenParsed$reve = pageTokenParsed.reverse) !== null && _pageTokenParsed$reve !== void 0 ? _pageTokenParsed$reve : inputOptions === null || inputOptions === void 0 ? void 0 : inputOptions.reverse,
        lastEvaluatedKey: pageTokenParsed.lastEvaluatedKey
      };
    }
  }, {
    key: "listAggregateIds",
    value: function () {
      var _listAggregateIds = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(context, options) {
        var _this4 = this,
            _results$;

        var _this$parseInputs, limit, initialEventAfter, initialEventBefore, reverse, lastEvaluatedKey, limitFilter, orderFilter, initialEventAfterFilter, initialEventBeforeFilter, filterRemainingCount, filterCurrentPage, query, results, remainingCount, aggregateIds, hasNextPage, parsedNextPageToken;

        return _regenerator["default"].wrap(function _callee5$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _this$parseInputs = this.parseInputs({
                  inputOptions: options
                }), limit = _this$parseInputs.limit, initialEventAfter = _this$parseInputs.initialEventAfter, initialEventBefore = _this$parseInputs.initialEventBefore, reverse = _this$parseInputs.reverse, lastEvaluatedKey = _this$parseInputs.lastEvaluatedKey;
                limitFilter = limit ? this._sql(_templateObject28 || (_templateObject28 = (0, _taggedTemplateLiteral2["default"])(["LIMIT ", ""])), limit) : this._sql(_templateObject29 || (_templateObject29 = (0, _taggedTemplateLiteral2["default"])([""])));
                orderFilter = reverse ? this._sql(_templateObject30 || (_templateObject30 = (0, _taggedTemplateLiteral2["default"])(["ORDER BY timestamp DESC"]))) : this._sql(_templateObject31 || (_templateObject31 = (0, _taggedTemplateLiteral2["default"])(["ORDER BY timestamp ASC"])));
                initialEventAfterFilter = initialEventAfter ? this._sql(_templateObject32 || (_templateObject32 = (0, _taggedTemplateLiteral2["default"])(["AND timestamp > ", ""])), initialEventAfter) : this._sql(_templateObject33 || (_templateObject33 = (0, _taggedTemplateLiteral2["default"])([""])));
                initialEventBeforeFilter = initialEventBefore ? this._sql(_templateObject34 || (_templateObject34 = (0, _taggedTemplateLiteral2["default"])(["AND timestamp < ", ""])), initialEventBefore) : this._sql(_templateObject35 || (_templateObject35 = (0, _taggedTemplateLiteral2["default"])([""])));

                filterRemainingCount = function filterRemainingCount() {
                  if (lastEvaluatedKey !== null && lastEvaluatedKey !== void 0 && lastEvaluatedKey.initialEventTimestamp) {
                    return reverse ? _this4._sql(_templateObject36 || (_templateObject36 = (0, _taggedTemplateLiteral2["default"])(["AND timestamp < ", ""])), lastEvaluatedKey.initialEventTimestamp) : _this4._sql(_templateObject37 || (_templateObject37 = (0, _taggedTemplateLiteral2["default"])(["AND timestamp > ", ""])), lastEvaluatedKey.initialEventTimestamp);
                  }

                  return _this4._sql(_templateObject38 || (_templateObject38 = (0, _taggedTemplateLiteral2["default"])([""])));
                };

                filterCurrentPage = function filterCurrentPage() {
                  if (lastEvaluatedKey !== null && lastEvaluatedKey !== void 0 && lastEvaluatedKey.initialEventTimestamp) {
                    return reverse ? _this4._sql(_templateObject39 || (_templateObject39 = (0, _taggedTemplateLiteral2["default"])(["AND timestamp < ", ""])), lastEvaluatedKey.initialEventTimestamp) : _this4._sql(_templateObject40 || (_templateObject40 = (0, _taggedTemplateLiteral2["default"])(["AND timestamp > ", ""])), lastEvaluatedKey.initialEventTimestamp);
                  }

                  return _this4._sql(_templateObject41 || (_templateObject41 = (0, _taggedTemplateLiteral2["default"])([""])));
                };

                query = this._sql(_templateObject42 || (_templateObject42 = (0, _taggedTemplateLiteral2["default"])(["\n      WITH aggregate_count AS (\n        SELECT COUNT(*) as remaining_count \n        FROM ", "\n        WHERE aggregate_name = ", "\n        AND version = 1\n        ", "\n        ", "\n\t\t\t\t", "\n      )\n      SELECT e.id, e.aggregate_id, e.timestamp, ac.remaining_count\n      FROM ", " e, aggregate_count ac\n      WHERE e.aggregate_name = ", "\n      AND e.version = 1\n      ", "\n      ", "\n\t\t\t", "\n      ", "\n      ", "\n    "])), this._sql.unsafe(this._tableName), context.eventStoreId, initialEventAfterFilter, initialEventBeforeFilter, filterRemainingCount(), this._sql.unsafe(this._tableName), context.eventStoreId, initialEventAfterFilter, initialEventBeforeFilter, filterCurrentPage(), orderFilter, limitFilter);
                _context6.next = 10;
                return query;

              case 10:
                results = _context6.sent;
                remainingCount = (_results$ = results[0]) !== null && _results$ !== void 0 && _results$.remaining_count ? Number(results[0].remaining_count) : 0;
                aggregateIds = results.map(function (_ref8) {
                  var aggregate_id = _ref8.aggregate_id,
                      timestamp = _ref8.timestamp;
                  return {
                    aggregateId: aggregate_id,
                    initialEventTimestamp: timestamp.toISOString()
                  };
                });
                hasNextPage = limit === undefined ? false : remainingCount > limit;
                parsedNextPageToken = {
                  limit: options === null || options === void 0 ? void 0 : options.limit,
                  initialEventAfter: options === null || options === void 0 ? void 0 : options.initialEventAfter,
                  initialEventBefore: options === null || options === void 0 ? void 0 : options.initialEventBefore,
                  reverse: options === null || options === void 0 ? void 0 : options.reverse,
                  lastEvaluatedKey: aggregateIds.at(-1)
                };
                return _context6.abrupt("return", _objectSpread({
                  aggregateIds: aggregateIds
                }, hasNextPage ? {
                  nextPageToken: JSON.stringify(parsedNextPageToken)
                } : {}));

              case 16:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee5, this);
      }));

      function listAggregateIds(_x9, _x10) {
        return _listAggregateIds.apply(this, arguments);
      }

      return listAggregateIds;
    }()
  }], [{
    key: "createClient",
    value: function createClient(_ref9) {
      var connectionString = _ref9.connectionString;
      return (0, _postgres["default"])(connectionString, {
        types: {
          bigint: _postgres["default"].BigInt
        },
        onnotice: function onnotice(notice) {
          // simple notice of already existing table, index, relation
          if (notice.severity === 'NOTICE') {
            return;
          }

          console.log(notice);
        }
      });
    } //TODO do all that in a single transaction

  }, {
    key: "createEventTable",
    value: function () {
      var _createEventTable = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var _ref10,
            _ref10$connectionStri,
            connectionString,
            _ref10$tableName,
            tableName,
            _ref10$idType,
            idType,
            _ref10$aggregateNameL,
            aggregateNameLength,
            _ref10$aggregateId,
            aggregateId,
            _ref10$versionType,
            versionType,
            _ref10$typeLength,
            typeLength,
            sql,
            aggregateIdType,
            _args7 = arguments;

        return _regenerator["default"].wrap(function _callee6$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _ref10 = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : {}, _ref10$connectionStri = _ref10.connectionString, connectionString = _ref10$connectionStri === void 0 ? 'postgresql://postgres:postgres@localhost:5432/postgres' : _ref10$connectionStri, _ref10$tableName = _ref10.tableName, tableName = _ref10$tableName === void 0 ? 'event' : _ref10$tableName, _ref10$idType = _ref10.idType, idType = _ref10$idType === void 0 ? 'BIGSERIAL' : _ref10$idType, _ref10$aggregateNameL = _ref10.aggregateNameLength, aggregateNameLength = _ref10$aggregateNameL === void 0 ? 32 : _ref10$aggregateNameL, _ref10$aggregateId = _ref10.aggregateId, aggregateId = _ref10$aggregateId === void 0 ? {
                  type: 'UUID'
                } : _ref10$aggregateId, _ref10$versionType = _ref10.versionType, versionType = _ref10$versionType === void 0 ? 'BIGINT' : _ref10$versionType, _ref10$typeLength = _ref10.typeLength, typeLength = _ref10$typeLength === void 0 ? 64 : _ref10$typeLength;
                sql = PostgresEventStorageAdapter.createClient({
                  connectionString: connectionString
                });
                aggregateIdType = aggregateId.type === 'VARCHAR' ? sql.unsafe("VARCHAR(".concat(aggregateId.length, ")")) : sql.unsafe(aggregateId.type);
                _context7.next = 5;
                return sql(_templateObject43 || (_templateObject43 = (0, _taggedTemplateLiteral2["default"])(["\n      CREATE TABLE IF NOT EXISTS ", " (\n        id              ", " PRIMARY KEY,\n        aggregate_name  ", " NOT NULL,\n        aggregate_id    ", " NOT NULL,\n        version         ", " NOT NULL,\n        type            ", " NOT NULL,\n        data            JSONB,\n        metadata        JSONB,\n        timestamp       TIMESTAMPTZ NOT NULL DEFAULT (CURRENT_TIMESTAMP(3)),\n        UNIQUE (aggregate_name, aggregate_id, version)\n      );\n    "])), sql.unsafe(tableName), sql.unsafe(idType), sql.unsafe("VARCHAR(".concat(aggregateNameLength, ")")), aggregateIdType, sql.unsafe(versionType), sql.unsafe("VARCHAR(".concat(typeLength, ")")));

              case 5:
                _context7.next = 7;
                return sql(_templateObject44 || (_templateObject44 = (0, _taggedTemplateLiteral2["default"])(["\n      CREATE INDEX IF NOT EXISTS idx_event_aggregate_name \n      ON ", "(aggregate_name);\n    "])), sql.unsafe(tableName));

              case 7:
                _context7.next = 9;
                return sql(_templateObject45 || (_templateObject45 = (0, _taggedTemplateLiteral2["default"])(["\n      CREATE INDEX IF NOT EXISTS idx_event_version\n      ON ", "(version);\n    "])), sql.unsafe(tableName));

              case 9:
                _context7.next = 11;
                return sql(_templateObject46 || (_templateObject46 = (0, _taggedTemplateLiteral2["default"])(["\n      CREATE INDEX IF NOT EXISTS idx_event_aggregate_lookup\n      ON ", "(aggregate_name, aggregate_id);\n    "])), sql.unsafe(tableName));

              case 11:
                _context7.next = 13;
                return sql.end();

              case 13:
                return _context7.abrupt("return", {
                  tableName: tableName
                });

              case 14:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee6);
      }));

      function createEventTable() {
        return _createEventTable.apply(this, arguments);
      }

      return createEventTable;
    }()
  }, {
    key: "dropEventTable",
    value: function () {
      var _dropEventTable = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(_ref11) {
        var _ref11$connectionStri, connectionString, _ref11$tableName, tableName, sql;

        return _regenerator["default"].wrap(function _callee7$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _ref11$connectionStri = _ref11.connectionString, connectionString = _ref11$connectionStri === void 0 ? 'postgresql://postgres:postgres@localhost:5432/postgres' : _ref11$connectionStri, _ref11$tableName = _ref11.tableName, tableName = _ref11$tableName === void 0 ? 'event' : _ref11$tableName;
                sql = PostgresEventStorageAdapter.createClient({
                  connectionString: connectionString
                });
                _context8.next = 4;
                return sql(_templateObject47 || (_templateObject47 = (0, _taggedTemplateLiteral2["default"])(["\n      DROP TABLE IF EXISTS ", ";\n    "])), sql.unsafe(tableName));

              case 4:
                _context8.next = 6;
                return sql.end();

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee7);
      }));

      function dropEventTable(_x11) {
        return _dropEventTable.apply(this, arguments);
      }

      return dropEventTable;
    }()
  }]);
  return PostgresEventStorageAdapter;
}();

exports.PostgresEventStorageAdapter = PostgresEventStorageAdapter;
//# sourceMappingURL=adapter.js.map